#ifndef FILEREADER_H
#define FILEREADER_H

#include <stdlib.h>

//-----------------------------------------------------------------
//  Think of the definitions here as describing an interface (in
//  Java).  There will be two implementations:
//   1. FileFileReader - already implemented and distributed
//   2. MappedFileReader - you will implement it
//  Both implementations define the methods declared below.
//  You can/must link only one of them when creating an
//  executable.
//-----------------------------------------------------------------

typedef unsigned int FileAddress;  // max file size is therefore limited to 4GB...

//----------------------------------------------------------------
// Correct use of these methods is:
//   1. Must call fileOpen() before doing anything else
//   2. Now can call fileRead() and fileSize() as often as you want
//   3. Should call fileClose() when done
//----------------------------------------------------------------

// 'extern' means we're providing just the type, but not the implementation
extern int    fileOpen( char* filename );
extern void   fileClose();

// 'void*' means its a pointer, but we don't know anything about the type
extern int    fileRead( FileAddress addr, size_t length, void* pResult );
extern int    fileSize(size_t* size);  // returns file size, in bytes, though argument

// These methods manage implementation-specific statistics.
// The first sets counters to zero.
// The second prints the counters.
extern void   fileResetStatistics();
extern void   filePrintStatistics();

#endif // FILEREADER_H

