#include <stdio.h>

#include "RecordStore.h"
#include "listArtists.h"

//---------------------------------------------------
// listArtists()
//   Prints all artist names, in sorted order
//   Returns 0 on success, non-zero otherwise.
//---------------------------------------------------

int listArtists(RecordAddress addr) {
  Record buffer;
  int rcode;

  // check for null pointer
  if ( !addr ) return 0;

  rcode = storeRead( addr, &buffer );
  if ( rcode ) return rcode;

  // print left subtree
  rcode = listArtists(buffer.leftPtr);
  if ( rcode ) return rcode;

  // print myself
  printf("'%s'\n", buffer.string);

  // print right subtree
  rcode = listArtists( buffer.rightPtr );

  return rcode;
}
