#include <stdio.h>

#include "RecordStore.h"
#include "printTree.h"

//---------------------------------------------------
// printTree()
//   Prints the entire subtree rooted at the given address.
//   (Arg depth is used just to help format the output.)
//   Returns 0 on success, non-zero otherwise.
//---------------------------------------------------

int printTree(RecordAddress addr, int depth) {
  Record buffer;
  int rcode;
  int d;

  // check for null pointer
  if ( !addr ) return 0;

  rcode = storeRead( addr, &buffer );
  if ( rcode ) return rcode;

  // print left subtree
  rcode = printTree(buffer.leftPtr, depth);
  if ( rcode ) return rcode;

  // print myself
  for (d=0; d<depth; d++ ) putchar('\t');
  printf("%s\n", buffer.string);
  rcode = printTree( buffer.childPtr, depth+1 );
  if ( rcode ) return rcode;

  // print right subtree
  rcode = printTree( buffer.rightPtr, depth );

  return rcode;
}
